Index: branches/SHM-dev/source/App/TAppEncoder/TAppEncLayerCfg.h
===================================================================
--- branches/SHM-dev/source/App/TAppEncoder/TAppEncLayerCfg.h	(revision 1011)
+++ branches/SHM-dev/source/App/TAppEncoder/TAppEncLayerCfg.h	(revision 1029)
@@ -10,4 +10,5 @@
 #include "TLibEncoder/TEncCfg.h"
 #include <sstream>
+#include <iomanip>
 
 using namespace std;
@@ -42,8 +43,12 @@
   Int       m_iIntraPeriod;                                   ///< period of I-slice (random access period)
   Double    m_fQP;                                            ///< QP value of key-picture (floating point)
+  ChromaFormat m_chromaFormatIDC;
+  ChromaFormat m_InputChromaFormatIDC;
+  ChromaFormat m_chromaFormatConstraint;
+  UInt      m_bitDepthConstraint;
+  Bool      m_intraConstraintFlag;
+  Bool      m_lowerBitRateConstraintFlag;
 #if AUXILIARY_PICTURES
-  ChromaFormat m_chromaFormatIDC;
-  ChromaFormat m_InputChromaFormat;
-  Int          m_auxId;
+  Int       m_auxId;
 #endif
 #if VPS_EXTN_DIRECT_REF_LAYERS
@@ -88,5 +93,5 @@
   Int*      m_aidQP;                                          ///< array of slice QP values
   TAppEncCfg* m_cAppEncCfg;                                   ///< pointer to app encoder config
-  Int       m_numScaledRefLayerOffsets  ;
+  Int       m_numScaledRefLayerOffsets;
 #if O0098_SCALED_REF_LAYER_ID
   Int       m_scaledRefLayerId          [MAX_LAYERS];
@@ -115,12 +120,12 @@
 #endif
 
-#if O0194_DIFFERENT_BITDEPTH_EL_BL
-  Int       m_inputBitDepthY;                               ///< bit-depth of input file (luma component)
-  Int       m_inputBitDepthC;                               ///< bit-depth of input file (chroma component)
-  Int       m_internalBitDepthY;                            ///< bit-depth codec operates at in luma (input/output files will be converted)
-  Int       m_internalBitDepthC;                            ///< bit-depth codec operates at in chroma (input/output files will be converted)
-  Int       m_outputBitDepthY;                              ///< bit-depth of output file (luma component)
-  Int       m_outputBitDepthC;                              ///< bit-depth of output file (chroma component)
-#endif
+  Int       m_inputBitDepth   [MAX_NUM_CHANNEL_TYPE];         ///< bit-depth of input file
+  Int       m_outputBitDepth  [MAX_NUM_CHANNEL_TYPE];         ///< bit-depth of output file
+  Int       m_MSBExtendedBitDepth[MAX_NUM_CHANNEL_TYPE];      ///< bit-depth of input samples after MSB extension
+  Int       m_internalBitDepth[MAX_NUM_CHANNEL_TYPE];         ///< bit-depth codec operates at (input/output files will be converted)
+  UInt      m_saoOffsetBitShift[MAX_NUM_CHANNEL_TYPE];
+  Bool      m_useExtendedPrecision;
+  Bool      m_useHighPrecisionPredictionWeighting;
+
 #if REPN_FORMAT_IN_VPS
   Int       m_repFormatIdx;
@@ -154,4 +159,9 @@
 #endif
 
+#if MULTIPLE_PTL_SUPPORT
+  // profile/level
+  Int       m_layerPTLIdx;
+#endif
+
 public:
   TAppEncLayerCfg();
@@ -182,5 +192,5 @@
   Int     getConfWinBottom()          {return m_confWinBottom;       }
 #if AUXILIARY_PICTURES
-  ChromaFormat getInputChromaFormat()   {return m_InputChromaFormat;}
+  ChromaFormat getInputChromaFormat()   {return m_InputChromaFormatIDC;}
   ChromaFormat getChromaFormatIDC()     {return m_chromaFormatIDC;  }
   Int          getAuxId()               {return m_auxId;            }
Index: branches/SHM-dev/source/App/TAppEncoder/TAppEncTop.cpp
===================================================================
--- branches/SHM-dev/source/App/TAppEncoder/TAppEncTop.cpp	(revision 1011)
+++ branches/SHM-dev/source/App/TAppEncoder/TAppEncTop.cpp	(revision 1029)
@@ -42,4 +42,7 @@
 #include <fcntl.h>
 #include <assert.h>
+#if !SVC_EXTENSION
+#include <iomanip>
+#endif
 
 #include "TAppEncTop.h"
@@ -80,5 +83,5 @@
   vps->setVpsPocLsbAlignedFlag(false);
 #endif
-  vps->setMaxTLayers                       ( m_maxTempLayer );
+  vps->setMaxTLayers                                                      ( m_maxTempLayer );
   if (m_maxTempLayer == 1)
   {
@@ -87,6 +90,6 @@
   for(Int i = 0; i < MAX_TLAYER; i++)
   {
-    vps->setNumReorderPics                 ( m_numReorderPics[i], i );
-    vps->setMaxDecPicBuffering             ( m_maxDecPicBuffering[i], i );
+    vps->setNumReorderPics                                                ( m_numReorderPics[i], i );
+    vps->setMaxDecPicBuffering                                            ( m_maxDecPicBuffering[i], i );
   }
 
@@ -107,5 +110,5 @@
 #endif
 #if O0194_DIFFERENT_BITDEPTH_EL_BL
-          && m_acLayerCfg[layer].m_internalBitDepthY == m_acLayerCfg[idx].m_internalBitDepthY && m_acLayerCfg[layer].m_internalBitDepthC == m_acLayerCfg[idx].m_internalBitDepthC
+          && m_acLayerCfg[layer].m_internalBitDepth[CHANNEL_TYPE_LUMA] == m_acLayerCfg[idx].m_internalBitDepth[CHANNEL_TYPE_LUMA] && m_acLayerCfg[layer].m_internalBitDepth[CHANNEL_TYPE_CHROMA] == m_acLayerCfg[idx].m_internalBitDepth[CHANNEL_TYPE_CHROMA]
 #endif
           )
@@ -150,11 +153,11 @@
   }
 
-  vps->setVpsNumRepFormats( maxRepFormatIdx + 1 );
+  vps->setVpsNumRepFormats                                                ( maxRepFormatIdx + 1 );
 
 #if Q0195_REP_FORMAT_CLEANUP
   // When not present, the value of rep_format_idx_present_flag is inferred to be equal to 0
-  vps->setRepFormatIdxPresentFlag( vps->getVpsNumRepFormats() > 1 ? true : false );
-#else
-  vps->setRepFormatIdxPresentFlag( true );
+  vps->setRepFormatIdxPresentFlag                                         ( vps->getVpsNumRepFormats() > 1 ? true : false );
+#else
+  vps->setRepFormatIdxPresentFlag                                         ( true );
 #endif
 
@@ -163,5 +166,5 @@
     RepFormat *repFormat = vps->getVpsRepFormat( idx );
 #if REPN_FORMAT_CONTROL_FLAG
-    repFormat->setChromaAndBitDepthVpsPresentFlag( true ); 
+    repFormat->setChromaAndBitDepthVpsPresentFlag                         ( true ); 
     if (idx==0)
     {
@@ -169,30 +172,29 @@
     }
 #endif 
-    repFormat->setPicWidthVpsInLumaSamples  ( m_acLayerCfg[mapIdxToLayer[idx]].getSourceWidth()   );
-    repFormat->setPicHeightVpsInLumaSamples ( m_acLayerCfg[mapIdxToLayer[idx]].getSourceHeight()  );
+    repFormat->setPicWidthVpsInLumaSamples                                ( m_acLayerCfg[mapIdxToLayer[idx]].getSourceWidth()   );
+    repFormat->setPicHeightVpsInLumaSamples                               ( m_acLayerCfg[mapIdxToLayer[idx]].getSourceHeight()  );
 #if AUXILIARY_PICTURES
-    repFormat->setChromaFormatVpsIdc        ( m_acLayerCfg[mapIdxToLayer[idx]].getChromaFormatIDC() );
-#else
-    repFormat->setChromaFormatVpsIdc        ( 1                                             );  // Need modification to change for each layer - corresponds to 420
-#endif
-    repFormat->setSeparateColourPlaneVpsFlag( 0                                             );  // Need modification to change for each layer
+    repFormat->setChromaFormatVpsIdc                                      ( m_acLayerCfg[mapIdxToLayer[idx]].getChromaFormatIDC() );
+#else
+    repFormat->setChromaFormatVpsIdc                                      ( 1 );  // Need modification to change for each layer - corresponds to 420
+#endif
+    repFormat->setSeparateColourPlaneVpsFlag                              ( 0 );  // Need modification to change for each layer
 #if O0194_DIFFERENT_BITDEPTH_EL_BL
-    repFormat->setBitDepthVpsLuma           ( getInternalBitDepthY(mapIdxToLayer[idx])      );  // Need modification to change for each layer
-    repFormat->setBitDepthVpsChroma         ( getInternalBitDepthC(mapIdxToLayer[idx])      );  // Need modification to change for each layer
-#else
-    repFormat->setBitDepthVpsLuma           ( getInternalBitDepthY()                        );  // Need modification to change for each layer
-    repFormat->setBitDepthVpsChroma         ( getInternalBitDepthC()                        );  // Need modification to change for each layer
+    repFormat->setBitDepthVpsLuma                                         ( getInternalBitDepth(mapIdxToLayer[idx], CHANNEL_TYPE_LUMA)      );  // Need modification to change for each layer
+    repFormat->setBitDepthVpsChroma                                       ( getInternalBitDepth(mapIdxToLayer[idx], CHANNEL_TYPE_CHROMA)    );  // Need modification to change for each layer
+#else
+    repFormat->setBitDepthVpsLuma                                         ( getInternalBitDepth(CHANNEL_TYPE_LUMA)                        );  // Need modification to change for each layer
+    repFormat->setBitDepthVpsChroma                                       ( getInternalBitDepth(CHANNEL_TYPE_CHROMA)                      );  // Need modification to change for each layer
 #endif
 
 #if R0156_CONF_WINDOW_IN_REP_FORMAT
-    repFormat->getConformanceWindowVps().setWindow(
-      m_acLayerCfg[mapIdxToLayer[idx]].m_confWinLeft, 
-      m_acLayerCfg[mapIdxToLayer[idx]].m_confWinRight, 
-      m_acLayerCfg[mapIdxToLayer[idx]].m_confWinTop,
-      m_acLayerCfg[mapIdxToLayer[idx]].m_confWinBottom );
+    repFormat->getConformanceWindowVps().setWindow                        ( m_acLayerCfg[mapIdxToLayer[idx]].m_confWinLeft,                                                                             
+                                                                            m_acLayerCfg[mapIdxToLayer[idx]].m_confWinRight, 
+                                                                            m_acLayerCfg[mapIdxToLayer[idx]].m_confWinTop,
+                                                                            m_acLayerCfg[mapIdxToLayer[idx]].m_confWinBottom );
 #endif
 
 #if HIGHER_LAYER_IRAP_SKIP_FLAG
-    m_acTEncTop[mapIdxToLayer[idx]].setSkipPictureAtArcSwitch( m_skipPictureAtArcSwitch );
+    m_acTEncTop[mapIdxToLayer[idx]].setSkipPictureAtArcSwitch             ( m_skipPictureAtArcSwitch );
 #endif
   }
@@ -203,5 +205,5 @@
   //Populate PTL in VPS
   TComVPS *pVPS = m_acTEncTop[0].getVPS();
-  for (int ii = 0; ii < m_numPTLInfo; ii++)
+  for( Int ii = 0; ii < m_numPTLInfo; ii++ )
   {
     pVPS->getPTL(ii)->getGeneralPTL()->setLevelIdc(m_levelList[ii]);
@@ -221,4 +223,5 @@
   {
     myvector =  m_listOfLayerPTLofOlss[ii];
+
     for (std::vector<int>::iterator it = myvector.begin() ; it != myvector.end(); ++it)
     {
@@ -226,6 +229,4 @@
     }
   }
-
-  //pVPS->setProfileLevelTierIdx(
 #endif
 
@@ -236,51 +237,65 @@
 #if O0194_DIFFERENT_BITDEPTH_EL_BL
     //1
-    g_bitDepthY = m_acLayerCfg[layer].m_internalBitDepthY;
-    g_bitDepthC = m_acLayerCfg[layer].m_internalBitDepthC;
-
-    g_uiPCMBitDepthLuma = m_bPCMInputBitDepthFlag ? m_acLayerCfg[layer].m_inputBitDepthY : m_acLayerCfg[layer].m_internalBitDepthY;
-    g_uiPCMBitDepthChroma = m_bPCMInputBitDepthFlag ? m_acLayerCfg[layer].m_inputBitDepthC : m_acLayerCfg[layer].m_internalBitDepthC;
+    g_bitDepth[CHANNEL_TYPE_LUMA]   = m_acLayerCfg[layer].m_internalBitDepth[CHANNEL_TYPE_LUMA];
+    g_bitDepth[CHANNEL_TYPE_CHROMA] = m_acLayerCfg[layer].m_internalBitDepth[CHANNEL_TYPE_CHROMA];
+
+    g_PCMBitDepth[CHANNEL_TYPE_LUMA]   = m_bPCMInputBitDepthFlag ? m_acLayerCfg[layer].m_inputBitDepth[CHANNEL_TYPE_LUMA]   : m_acLayerCfg[layer].m_internalBitDepth[CHANNEL_TYPE_LUMA];
+    g_PCMBitDepth[CHANNEL_TYPE_CHROMA] = m_bPCMInputBitDepthFlag ? m_acLayerCfg[layer].m_inputBitDepth[CHANNEL_TYPE_CHROMA] : m_acLayerCfg[layer].m_internalBitDepth[CHANNEL_TYPE_CHROMA];
 
     // Set this to be used in Upsampling filter in function "TComUpsampleFilter::upsampleBasePic"
-    g_bitDepthYLayer[layer] = g_bitDepthY;
-    g_bitDepthCLayer[layer] = g_bitDepthC;
+    g_bitDepthLayer[CHANNEL_TYPE_LUMA][layer]   = g_bitDepth[CHANNEL_TYPE_LUMA];
+    g_bitDepthLayer[CHANNEL_TYPE_CHROMA][layer] = g_bitDepth[CHANNEL_TYPE_CHROMA];
 
 #if O0194_WEIGHTED_PREDICTION_CGS
-    m_acTEncTop[layer].setInterLayerWeightedPredFlag( m_useInterLayerWeightedPred );
-#endif
-#endif
-    //m_acTEncTop[layer].setVPS(&vps);
-    m_acTEncTop[layer].setFrameRate                    ( m_acLayerCfg[layer].getFrameRate() );
-    m_acTEncTop[layer].setFrameSkip                    ( m_FrameSkip );
-    m_acTEncTop[layer].setSourceWidth                  ( m_acLayerCfg[layer].getSourceWidth() );
-    m_acTEncTop[layer].setSourceHeight                 ( m_acLayerCfg[layer].getSourceHeight() );
-    m_acTEncTop[layer].setConformanceWindow            ( m_acLayerCfg[layer].m_confWinLeft, m_acLayerCfg[layer].m_confWinRight, m_acLayerCfg[layer].m_confWinTop, m_acLayerCfg[layer].m_confWinBottom );
-    m_acTEncTop[layer].setFramesToBeEncoded            ( m_framesToBeEncoded );
-
-#if SVC_EXTENSION && MULTIPLE_PTL_SUPPORT
-    m_acTEncTop[layer].setProfile(m_profileList[m_layerPTLIdx[layer]]);
-    m_acTEncTop[layer].setLevel(m_levelTierList[m_layerPTLIdx[layer]], m_levelList[m_layerPTLIdx[layer]]);
-    m_acTEncTop[layer].setProgressiveSourceFlag(m_progressiveSourceFlagList[m_layerPTLIdx[layer]]);
-    m_acTEncTop[layer].setInterlacedSourceFlag(m_interlacedSourceFlagList[m_layerPTLIdx[layer]]);
-    m_acTEncTop[layer].setNonPackedConstraintFlag(m_nonPackedConstraintFlagList[m_layerPTLIdx[layer]]);
-    m_acTEncTop[layer].setFrameOnlyConstraintFlag(m_frameOnlyConstraintFlagList[m_layerPTLIdx[layer]]);
-#else
-    m_acTEncTop[layer].setProfile(m_profile);
-    m_acTEncTop[layer].setLevel(m_levelTier, m_level);
-    m_acTEncTop[layer].setProgressiveSourceFlag(m_progressiveSourceFlag);
-    m_acTEncTop[layer].setInterlacedSourceFlag(m_interlacedSourceFlag);
-    m_acTEncTop[layer].setNonPackedConstraintFlag(m_nonPackedConstraintFlag);
-    m_acTEncTop[layer].setFrameOnlyConstraintFlag(m_frameOnlyConstraintFlag);
-#endif
+    m_acTEncTop[layer].setInterLayerWeightedPredFlag                      ( m_useInterLayerWeightedPred );
+#endif
+#endif
+    
+#if MULTIPLE_PTL_SUPPORT
+    Int layerPTLIdx = m_acLayerCfg[layer].m_layerPTLIdx;
+    m_acTEncTop[layer].setProfile                                         ( m_profileList[layerPTLIdx] );
+    m_acTEncTop[layer].setLevel                                           ( m_levelTierList[layerPTLIdx], m_levelList[layerPTLIdx] );
+    m_acTEncTop[layer].setProgressiveSourceFlag                           ( m_progressiveSourceFlagList[layerPTLIdx] );
+    m_acTEncTop[layer].setInterlacedSourceFlag                            ( m_interlacedSourceFlagList[layerPTLIdx] );
+    m_acTEncTop[layer].setNonPackedConstraintFlag                         ( m_nonPackedConstraintFlagList[layerPTLIdx] );
+    m_acTEncTop[layer].setFrameOnlyConstraintFlag                         ( m_frameOnlyConstraintFlagList[layerPTLIdx] );
+    m_acTEncTop[layer].setBitDepthConstraintValue                         ( m_acLayerCfg[layer].m_bitDepthConstraint );
+    m_acTEncTop[layer].setChromaFormatConstraintValue                     ( m_acLayerCfg[layer].m_chromaFormatConstraint );
+    m_acTEncTop[layer].setIntraConstraintFlag                             ( m_acLayerCfg[layer].m_intraConstraintFlag );
+    m_acTEncTop[layer].setLowerBitRateConstraintFlag                      ( m_acLayerCfg[layer].m_lowerBitRateConstraintFlag );
+#else
+    m_acTEncTop[layer].setProfile                                         ( m_profile );
+    m_acTEncTop[layer].setLevel                                           ( m_levelTier, m_level );
+    m_acTEncTop[layer].setProgressiveSourceFlag                           ( m_progressiveSourceFlag );
+    m_acTEncTop[layer].setInterlacedSourceFlag                            ( m_interlacedSourceFlag );
+    m_acTEncTop[layer].setNonPackedConstraintFlag                         ( m_nonPackedConstraintFlag );
+    m_acTEncTop[layer].setFrameOnlyConstraintFlag                         ( m_frameOnlyConstraintFlag );
+    m_acTEncTop[layer].setBitDepthConstraintValue                         ( m_bitDepthConstraint );
+    m_acTEncTop[layer].setChromaFormatConstraintValue                     ( m_acLayerCfg[layer].m_chromaFormatConstraint );
+    m_acTEncTop[layer].setIntraConstraintFlag                             ( m_intraConstraintFlag );
+    m_acTEncTop[layer].setLowerBitRateConstraintFlag                      ( m_lowerBitRateConstraintFlag );
+#endif
+
+    m_acTEncTop[layer].setPrintMSEBasedSequencePSNR                       ( m_printMSEBasedSequencePSNR);
+    m_acTEncTop[layer].setPrintFrameMSE                                   ( m_printFrameMSE);
+    m_acTEncTop[layer].setPrintSequenceMSE                                ( m_printSequenceMSE);
+    m_acTEncTop[layer].setCabacZeroWordPaddingEnabled                     ( m_cabacZeroWordPaddingEnabled );
+
+    m_acTEncTop[layer].setFrameRate                                       ( m_acLayerCfg[layer].getFrameRate() );
+    m_acTEncTop[layer].setFrameSkip                                       ( m_FrameSkip );
+    m_acTEncTop[layer].setSourceWidth                                     ( m_acLayerCfg[layer].getSourceWidth() );
+    m_acTEncTop[layer].setSourceHeight                                    ( m_acLayerCfg[layer].getSourceHeight() );
+    m_acTEncTop[layer].setConformanceWindow                               ( m_acLayerCfg[layer].m_confWinLeft, m_acLayerCfg[layer].m_confWinRight, m_acLayerCfg[layer].m_confWinTop, m_acLayerCfg[layer].m_confWinBottom );
+    m_acTEncTop[layer].setFramesToBeEncoded                               ( m_framesToBeEncoded );
 
 #if REF_IDX_MFM
 #if AVC_BASE
 #if VPS_AVC_BL_FLAG_REMOVAL
-    m_acTEncTop[layer].setMFMEnabledFlag(layer == 0 ? false : ( m_nonHEVCBaseLayerFlag ? false : true ) && m_acLayerCfg[layer].getNumMotionPredRefLayers());
-#else
-    m_acTEncTop[layer].setMFMEnabledFlag(layer == 0 ? false : ( m_avcBaseLayerFlag ? false : true ) && m_acLayerCfg[layer].getNumMotionPredRefLayers());
-#endif
-#else
-    m_acTEncTop[layer].setMFMEnabledFlag(layer == 0 ? false : ( m_acLayerCfg[layer].getNumMotionPredRefLayers() > 0 ) );
+    m_acTEncTop[layer].setMFMEnabledFlag                                  (layer == 0 ? false : ( m_nonHEVCBaseLayerFlag ? false : true ) && m_acLayerCfg[layer].getNumMotionPredRefLayers());
+#else
+    m_acTEncTop[layer].setMFMEnabledFlag                                  (layer == 0 ? false : ( m_avcBaseLayerFlag ? false : true ) && m_acLayerCfg[layer].getNumMotionPredRefLayers());
+#endif
+#else
+    m_acTEncTop[layer].setMFMEnabledFlag                                  (layer == 0 ? false : ( m_acLayerCfg[layer].getNumMotionPredRefLayers() > 0 ) );
 #endif
 #endif
@@ -291,40 +306,40 @@
 
     //====== Coding Structure ========
-    m_acTEncTop[layer].setIntraPeriod                  ( m_acLayerCfg[layer].m_iIntraPeriod );
-    m_acTEncTop[layer].setDecodingRefreshType          ( m_iDecodingRefreshType );
-    m_acTEncTop[layer].setGOPSize                      ( m_iGOPSize );
+    m_acTEncTop[layer].setIntraPeriod                                     ( m_acLayerCfg[layer].m_iIntraPeriod );
+    m_acTEncTop[layer].setDecodingRefreshType                             ( m_iDecodingRefreshType );
+    m_acTEncTop[layer].setGOPSize                                         ( m_iGOPSize );
 #if Q0108_TSA_STSA
-    m_acTEncTop[layer].setGopList                      ( layer ? m_EhGOPList[layer] : m_GOPList );
-#else
-    m_acTEncTop[layer].setGopList                      ( m_GOPList );
+    m_acTEncTop[layer].setGopList                                         ( layer ? m_EhGOPList[layer] : m_GOPList );
+#else
+    m_acTEncTop[layer].setGopList                                         ( m_GOPList );
 #endif
 
 #if !Q0108_TSA_STSA
-    m_acTEncTop[layer].setExtraRPSs                    ( m_extraRPSs );
-#else
-    m_acTEncTop[layer].setExtraRPSs                    ( m_extraRPSs[layer] );
+    m_acTEncTop[layer].setExtraRPSs                                       ( m_extraRPSs );
+#else
+    m_acTEncTop[layer].setExtraRPSs                                       ( m_extraRPSs[layer] );
 #endif
     for(Int i = 0; i < MAX_TLAYER; i++)
     {
-      m_acTEncTop[layer].setNumReorderPics             ( m_numReorderPics[i], i );
-      m_acTEncTop[layer].setMaxDecPicBuffering         ( m_maxDecPicBuffering[i], i );
+      m_acTEncTop[layer].setNumReorderPics                                ( m_numReorderPics[i], i );
+      m_acTEncTop[layer].setMaxDecPicBuffering                            ( m_maxDecPicBuffering[i], i );
     }
     for( UInt uiLoop = 0; uiLoop < MAX_TLAYER; ++uiLoop )
     {
-      m_acTEncTop[layer].setLambdaModifier( uiLoop, m_adLambdaModifier[ uiLoop ] );
-    }
-    m_acTEncTop[layer].setQP                           ( m_acLayerCfg[layer].getIntQP() );
-
-    m_acTEncTop[layer].setPad                          ( m_acLayerCfg[layer].getPad() );
+      m_acTEncTop[layer].setLambdaModifier                                ( uiLoop, m_adLambdaModifier[ uiLoop ] );
+    }
+    m_acTEncTop[layer].setQP                                              ( m_acLayerCfg[layer].getIntQP() );
+
+    m_acTEncTop[layer].setPad                                             ( m_acLayerCfg[layer].getPad() );
 #if !Q0108_TSA_STSA
-    m_acTEncTop[layer].setMaxTempLayer                 ( m_maxTempLayer );
+    m_acTEncTop[layer].setMaxTempLayer                                    ( m_maxTempLayer );
 #else
     if (layer== 0)
     {
-      m_acTEncTop[layer].setMaxTempLayer                 ( m_maxTempLayer );
+      m_acTEncTop[layer].setMaxTempLayer                                  ( m_maxTempLayer );
     }
     else
     {
-      m_acTEncTop[layer].setMaxTempLayer                 ( m_EhMaxTempLayer[layer] );
+      m_acTEncTop[layer].setMaxTempLayer                                  ( m_EhMaxTempLayer[layer] );
     }
 #endif
@@ -333,5 +348,5 @@
     if( layer < m_numLayers - 1 )
     {
-       m_acTEncTop[layer].setMaxTidIlRefPicsPlus1 ( m_acLayerCfg[layer].getMaxTidIlRefPicsPlus1());
+       m_acTEncTop[layer].setMaxTidIlRefPicsPlus1                         ( m_acLayerCfg[layer].getMaxTidIlRefPicsPlus1());
     }
 
@@ -341,21 +356,21 @@
       for(Int i = 0; i < MAX_VPS_LAYER_ID_PLUS1; i++)
       {
-        m_acTEncTop[layer].setSamplePredEnabledFlag(i, false);
-        m_acTEncTop[layer].setMotionPredEnabledFlag(i, false);
+        m_acTEncTop[layer].setSamplePredEnabledFlag                       (i, false);
+        m_acTEncTop[layer].setMotionPredEnabledFlag                       (i, false);
       }
       if(m_acLayerCfg[layer].getNumSamplePredRefLayers() == -1)
       {
         // Not included in the configuration file; assume that each layer depends on previous layer
-        m_acTEncTop[layer].setNumSamplePredRefLayers   (1);      // One sample pred ref. layer
-        m_acTEncTop[layer].setSamplePredRefLayerId     (0, layer - 1);   // Previous layer
-        m_acTEncTop[layer].setSamplePredEnabledFlag    (layer - 1, true);
+        m_acTEncTop[layer].setNumSamplePredRefLayers                      (1);      // One sample pred ref. layer
+        m_acTEncTop[layer].setSamplePredRefLayerId                        (0, layer - 1);   // Previous layer
+        m_acTEncTop[layer].setSamplePredEnabledFlag                       (layer - 1, true);
       }
       else
       {
-        m_acTEncTop[layer].setNumSamplePredRefLayers   ( m_acLayerCfg[layer].getNumSamplePredRefLayers() );
+        m_acTEncTop[layer].setNumSamplePredRefLayers                      ( m_acLayerCfg[layer].getNumSamplePredRefLayers() );
         for(Int i = 0; i < m_acTEncTop[layer].getNumSamplePredRefLayers(); i++)
         {
-          m_acTEncTop[layer].setSamplePredRefLayerId   ( i, m_acLayerCfg[layer].getSamplePredRefLayerId(i));
-          m_acTEncTop[layer].setSamplePredEnabledFlag  (m_acLayerCfg[layer].getSamplePredRefLayerId(i), true);
+          m_acTEncTop[layer].setSamplePredRefLayerId                      ( i, m_acLayerCfg[layer].getSamplePredRefLayerId(i));
+          m_acTEncTop[layer].setSamplePredEnabledFlag                     (m_acLayerCfg[layer].getSamplePredRefLayerId(i), true);
         }
       }
@@ -363,15 +378,15 @@
       {
         // Not included in the configuration file; assume that each layer depends on previous layer
-        m_acTEncTop[layer].setNumMotionPredRefLayers   (1);      // One motion pred ref. layer
-        m_acTEncTop[layer].setMotionPredRefLayerId     (0, layer - 1);   // Previous layer
-        m_acTEncTop[layer].setMotionPredEnabledFlag    (layer - 1, true);
+        m_acTEncTop[layer].setNumMotionPredRefLayers                      (1);      // One motion pred ref. layer
+        m_acTEncTop[layer].setMotionPredRefLayerId                        (0, layer - 1);   // Previous layer
+        m_acTEncTop[layer].setMotionPredEnabledFlag                       (layer - 1, true);
       }
       else
       {
-        m_acTEncTop[layer].setNumMotionPredRefLayers   ( m_acLayerCfg[layer].getNumMotionPredRefLayers() );
+        m_acTEncTop[layer].setNumMotionPredRefLayers                      ( m_acLayerCfg[layer].getNumMotionPredRefLayers() );
         for(Int i = 0; i < m_acTEncTop[layer].getNumMotionPredRefLayers(); i++)
         {
-          m_acTEncTop[layer].setMotionPredRefLayerId   ( i, m_acLayerCfg[layer].getMotionPredRefLayerId(i));
-          m_acTEncTop[layer].setMotionPredEnabledFlag  (m_acLayerCfg[layer].getMotionPredRefLayerId(i), true);
+          m_acTEncTop[layer].setMotionPredRefLayerId                      ( i, m_acLayerCfg[layer].getMotionPredRefLayerId(i));
+          m_acTEncTop[layer].setMotionPredEnabledFlag                     (m_acLayerCfg[layer].getMotionPredRefLayerId(i), true);
         }
       }
@@ -384,13 +399,13 @@
         if (m_acTEncTop[layer].getSamplePredEnabledFlag(i) || m_acTEncTop[layer].getMotionPredEnabledFlag(i))
         {
-          m_acTEncTop[layer].setRefLayerId(numDirectRefLayers, i);
+          m_acTEncTop[layer].setRefLayerId                                (numDirectRefLayers, i);
           numDirectRefLayers++;
         }
       }
-      m_acTEncTop[layer].setNumDirectRefLayers(numDirectRefLayers);
+      m_acTEncTop[layer].setNumDirectRefLayers                            (numDirectRefLayers);
 
       if(m_acLayerCfg[layer].getNumActiveRefLayers() == -1)
       {
-        m_acTEncTop[layer].setNumActiveRefLayers( m_acTEncTop[layer].getNumDirectRefLayers() );
+        m_acTEncTop[layer].setNumActiveRefLayers                          ( m_acTEncTop[layer].getNumDirectRefLayers() );
         for( Int i = 0; i < m_acTEncTop[layer].getNumActiveRefLayers(); i++ )
         {
@@ -400,8 +415,8 @@
       else
       {
-        m_acTEncTop[layer].setNumActiveRefLayers       ( m_acLayerCfg[layer].getNumActiveRefLayers() );
+        m_acTEncTop[layer].setNumActiveRefLayers                          ( m_acLayerCfg[layer].getNumActiveRefLayers() );
         for(Int i = 0; i < m_acTEncTop[layer].getNumActiveRefLayers(); i++)
         {
-          m_acTEncTop[layer].setPredLayerId             ( i, m_acLayerCfg[layer].getPredLayerId(i));
+          m_acTEncTop[layer].setPredLayerId                               ( i, m_acLayerCfg[layer].getPredLayerId(i));
         }
       }
@@ -417,7 +432,7 @@
         Int rlSubHeightC = 2;
 #endif
-        m_acTEncTop[layer].setRefRegionOffsetPresentFlag( i, m_acLayerCfg[layer].m_refRegionOffsetPresentFlag[i] );
-        m_acTEncTop[layer].getRefLayerWindow(i).setWindow( rlSubWidthC  * m_acLayerCfg[layer].m_refRegionLeftOffset[i], rlSubWidthC  * m_acLayerCfg[layer].m_refRegionRightOffset[i],
-                                                           rlSubHeightC * m_acLayerCfg[layer].m_refRegionTopOffset[i],  rlSubHeightC * m_acLayerCfg[layer].m_refRegionBottomOffset[i]);
+        m_acTEncTop[layer].setRefRegionOffsetPresentFlag                  ( i, m_acLayerCfg[layer].m_refRegionOffsetPresentFlag[i] );
+        m_acTEncTop[layer].getRefLayerWindow(i).setWindow                 ( rlSubWidthC  * m_acLayerCfg[layer].m_refRegionLeftOffset[i], rlSubWidthC  * m_acLayerCfg[layer].m_refRegionRightOffset[i],
+                                                                            rlSubHeightC * m_acLayerCfg[layer].m_refRegionTopOffset[i],  rlSubHeightC * m_acLayerCfg[layer].m_refRegionBottomOffset[i]);
       }
 #endif
